<?php
# Mantis - a php based bugtracking system

# Copyright (C) 2000 - 2002  Kenzaburo Ito - kenito@300baud.org
# Copyright (C) 2002 - 2007  Mantis Team   - mantisbt-dev@lists.sourceforge.net

# Mantis is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# Mantis is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Mantis.  If not, see <http://www.gnu.org/licenses/>.

	# --------------------------------------------------------
	# $Id:$
	# --------------------------------------------------------

	# This include file prints out the bug bugnote_stats
	require_once( 'core.php' );

	$t_core_path = config_get( 'core_path' );
	$t_mantis_dir = dirname( __FILE__ ) . DIRECTORY_SEPARATOR;

	$t_core_path = config_get( 'core_path' );

	require_once( $t_core_path.'bugnote_api.php' );

	if ( !config_get( 'time_tracking_enabled' ) ) {
		return;
	}

	$f_from = gpc_get_string( 'from', '' );
	$f_to = gpc_get_string( 'to', '' );
	$f_bugnote_cost = gpc_get_int( 'bugnote_cost', '' );
	$f_project_id = helper_get_current_project();

	$t_cost_col = ( ON == config_get( 'time_tracking_with_billing' ) );

	if ( !is_blank( $f_from ) && !is_blank( $f_to ) ) {
		# get the fields list
		$t_field_name_arr = array( lang_get( 'id' ), lang_get( 'summary' ), lang_get( 'username' ), lang_get( 'time_tracking' ), lang_get( 'time_tracking_cost' ) );
		$field_name_count = count( $t_field_name_arr );
		if ( !$t_cost_col ) {
			$field_name_count--;  // Remove cost
		}

		helper_begin_long_process();

		# excel or html export
		$t_export_title = helper_get_default_export_filename( '' );
		$t_export_title = ereg_replace( '[\/:*?"<>|]', '', $t_export_title );

		# Make sure that IE can download the attachments under https.
		header( 'Pragma: public' );

		header( 'Content-Type: application/vnd.ms-excel' );

		if ( preg_match( "/MSIE/", $_SERVER["HTTP_USER_AGENT"] ) ) {
			header( 'Content-Disposition: attachment; filename="' . urlencode( $t_export_title ) . '.xls"' ) ;
		} else {
			header( 'Content-Disposition: attachment; filename="' . $t_export_title . '.xls"' );
		}

		$t_bugnote_stats = bugnote_stats_get_project_array( $f_project_id, $f_from, $f_to, $f_bugnote_cost );

		if ( is_blank( $f_bugnote_cost ) || ( (double)$f_bugnote_cost == 0 ) ) {
			$t_cost_col = false;
		}

		$t_prev_id = -1;

		echo( 
"<?xml version=\"1.0\"?>
<?mso-application progid=\"Excel.Sheet\"?>" );
?>
<Workbook
   xmlns="urn:schemas-microsoft-com:office:spreadsheet"
   xmlns:o="urn:schemas-microsoft-com:office:office"
   xmlns:x="urn:schemas-microsoft-com:office:excel"
   xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
   xmlns:html="http://www.w3.org/TR/REC-html40">
  <DocumentProperties xmlns="urn:schemas-microsoft-com:office:office">
    <Author>Mantis</Author>
    <LastAuthor>Mantis</LastAuthor>
    <Created><? echo( date('c')); ?></Created>
    <Company></Company>
    <Version>11.8036</Version>
  </DocumentProperties>
  <ExcelWorkbook xmlns="urn:schemas-microsoft-com:office:excel">
    <WindowHeight>6795</WindowHeight>
    <WindowWidth>8460</WindowWidth>
    <WindowTopX>120</WindowTopX>
    <WindowTopY>15</WindowTopY>
    <ProtectStructure>False</ProtectStructure>
    <ProtectWindows>False</ProtectWindows>
  </ExcelWorkbook>
  <Styles>
    <Style ss:ID="Default" ss:Name="Normal">
      <Alignment ss:Vertical="Bottom" />
      <Borders />
      <Font />
      <Interior />
      <NumberFormat />
      <Protection />
    </Style>
    <Style ss:ID="s21">
      <Font x:Family="Swiss" ss:Bold="1" />
    </Style>
  </Styles>
  <Worksheet ss:Name="<?php echo( lang_get( 'time_tracking_billing_link' ) ); ?>">
    <Table ss:ExpandedColumnCount="<?php echo $field_name_count; ?>" ss:ExpandedRowCount="<?php echo( count($t_bugnote_stats)+1); ?>"
           x:FullColumns="1" x:FullRows="1">
<Row>
<?php for ( $i=0 ; $i <$field_name_count ; $i++ ) { ?>
  <Cell ss:StyleID="s21"><Data ss:Type="String"><?php echo $t_field_name_arr[$i]; ?></Data></Cell>
<?php } //for ?>
</Row>

<?php
  foreach ( $t_bugnote_stats as $t_item ) {
?>
<Row>
  <Cell><Data ss:Type="Number"><?php echo $t_item['bug_id']; ?></Data></Cell>
  <Cell><Data ss:Type="String"><?php echo $t_item['summary']; ?></Data></Cell>
  <Cell><Data ss:Type="String"><?php echo $t_item['username']; ?></Data></Cell>
  <Cell><Data ss:Type="Number"><?php echo $t_item['sum_time_tracking']; ?></Data></Cell>
<?php if ($t_cost_col) { ?>
  <Cell><Data ss:Type="Number"><?php echo string_attribute( number_format( $t_item['cost'], 2 ) ); ?></Data></Cell>
<?php } ?>
</Row>
<?php } # end for loop ?>  
 
    </Table>
    <WorksheetOptions xmlns="urn:schemas-microsoft-com:office:excel">
      <Print>
        <ValidPrinterInfo />
        <HorizontalResolution>600</HorizontalResolution>
        <VerticalResolution>600</VerticalResolution>
      </Print>
      <Selected />
      <Panes>
        <Pane>
          <Number>3</Number>
          <ActiveRow>5</ActiveRow>
          <ActiveCol>1</ActiveCol>
        </Pane>
      </Panes>
      <ProtectObjects>False</ProtectObjects>
      <ProtectScenarios>False</ProtectScenarios>
    </WorksheetOptions>
  </Worksheet>
</Workbook>
<?php
	} # end if
?>